/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

//
//  mdbtypes2.h

#ifndef mdbtypes2_h
#define mdbtypes2_h


//  Datatype, file and path platform specifics
#if defined(WIN32)
#define FN_PATHSEP      "\\"
#define FN_PATHSEPC     '\\'
#define MAX_PATH_LEN    255


#elif defined(__VMS)
#define FN_PATHSEP      "]"
#define FN_PATHSEPC     ']'
#define MAX_PATH_LEN    255


#elif defined(UNIX)
#include <limits.h>
#include <sys/types.h>
#include <unistd.h>
#define FN_PATHSEP      "/"
#define FN_PATHSEPC     '/'
#define MAX_PATH_LEN    PATH_MAX

#endif

#if defined(WIN32)
#include <winsock.h>
#include <io.h>
typedef int             MDBPID;
typedef long            OFF_T;
typedef fd_set          MDBFDMASK;
// File access check modes (for access() system call)
// These symbols already defined on real operating systems
#define R_OK            4   // read permission.
#define W_OK            2   // write permission.
#define F_OK            0   // Check existence of file


#elif defined(__VMS)
#include <time.h>
typedef int             MDBPID;
typedef long            OFF_T;
typedef fd_set          MDBFDMASK;

//
// LINUX Port Changes
//
// Added Linux to defined types
#elif defined(SUN) || defined(LINUX) || defined(HPV11)
typedef pid_t           MDBPID;
typedef off_t           OFF_T;
typedef fd_set          MDBFDMASK;

#elif defined(HPV9) || defined(HPV10)   /* HPUX 9.x */
typedef pid_t           MDBPID;
typedef off_t           OFF_T;
typedef int             MDBFDMASK;

#endif

#endif // mdbtypes2_h
