/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _CECTIMER_H_
#define _CECTIMER_H_
#include "definition.h"

class CECTimer
{
public:
    // @cmember Constructor
    CECTimer();

    // @cmember Destructor (virtual)
    virtual ~CECTimer();

    // @cmember Start the timer running
    int     Start       ();

    // @cmember Stop the timer
    int     Stop        ();

    // @cmember Get the elapsed timer for the timer
    int     ElapsedTime () const
    {
        return m_ElapsedTime;
    }

    // @cmember Determine if the timer is still running.
    bool    Running     () const
    {
        return m_Running;
    }

protected:
    // @cmember Function to calculate the elapsed time for a timer.
    void    SetElapsedTime  (int StopDate ,int StopTime);

    // @cmember Function to Recover the current date/time
    void    GetTime         (int* Date ,int* Time);


    // @cmember Day at which this timer was started (as returned by gettimeofday)
    int     m_StartDate;

    // @cmember Time at which this timer was started (as returned by gettimeofday)
    int     m_StartTime;

    int     m_ElapsedTime;

    bool    m_Running;
};
#endif
