/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TRecMake.h
#ifndef _CYR_TRECMAKE_H
#define _CYR_TRECMAKE_H
/**
 * Class definition for rule defining Language Transaction Record
 **/

// local includes
#include "TRecCreator.h"
#include "SharedPointer.hpp"

typedef map< AtvfKey, SharedPtr<TRecCreator>, less<AtvfKey> > RecCreator_map_t;

template<class T>
class TRecMake : public TRecCreator
{

public:
    // constructors & destructor
    // accessors
    virtual TRecord* create() const
    {
        T* t = new T(_typRuleP);

        if(!_options.empty()) t->addOptions(_options);

        if(!_params.empty())
        {
            for(prulep_vect_t::const_iterator i = _params.begin();
                    i != _params.end();
                    i++)
            {
                t->addParam(*i);
            }
        }
        return t;
    }
}
; // TRecMake

// Prototype for function which uses above template
SharedPtr<TRecCreator> getTRecCreator(const AtvfKey& key);

#endif // _CYR_TRECMAKE_H
