/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TaskScript.cpp
/**
 * Method definitions for the TaskScript class
 **/

// local includes
#include "TContext.h"
#include "TaskScript.h"
/**
 * Constructor, create a script object from the script name given.
 * This will involve loading from a file.
 **/
TaskScript::TaskScript(const TScriptRule* ruleP, const string& scriptname)
        :   _name(scriptname)
{
    AtvfInput tmpAtvfInput(scriptname.c_str());
    _script=new TScript(ruleP, tmpAtvfInput);
}
/**
 * Destructor
 **/
TaskScript::~TaskScript()
{
    delete _script;
}

/**
 * Accessor to find the size of this Object.
 **/
unsigned int TaskScript::size()
{
    return _script->length();
}

