#ifndef PSL_MEM_RTNS_LOADED
#define PSL_MEM_RTNS_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*                **** V - T E S T ****                          */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: MEM_RTNS                        */
/*          =====================                        */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  This module contains prototypes for memory allocation & deallocation */
/*  functions for use by PSL code that requires trackling of its memory  */
/*  useage                                   */
/*                                       */
/*  PSL_MALLOC  - Allocates memory with trace information        */
/*  PSL_FREE    - Deallocates memory, checking trace data        */
/*  PSL_MEM_DEBUG   - Debugging hook to alert the developer of errors    */
/*                                       */
/*===========================================================================*/
void *  PSL_MALLOC  (size_t ammount);
void    PSL_FREE    (void * mem);
void *  PSL_CALLOC  (size_t nobj, size_t size);
void    PSL_MEM_DEBUG   (void);
#endif                              /*PSL_MEM_RTNS_LOADED*/
