#ifndef PSL__PSL_VM_SKEYDEF_LOADED
#define PSL__PSL_VM_SKEYDEF_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: PSL_VM_PRMDEF               */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  This module defines the structure of the key used by the         */
/*  PSL_VM_SORT routine.                             */
/*                                       */
/*===========================================================================*/

/*** MODULE PSL_VM_SKEYDEF ***/

struct psl_vm_skey
{

    /*  Data type of field to be sorted.         */

    PSL_U_LONGWORD_T        key_typel;
#define            SKTYP_NONE 0
#define            SKTYP_ULONG 1
#define            SKTYP_TEXT 2

    /*      Added SKTYP_UINT specifically for lsa where the stats file has been */
    /*  changed to use ints in order to make it portable. */

#define            SKTYP_UINT 3

    /*  Offset (in bytes) starting at zero, of key within buffer. */

    PSL_U_LONGWORD_T        key_offsetl;

    /*  Length of key (in bytes) within buffer. */

    PSL_U_LONGWORD_T        key_lengthl;

    /*  Reverse order flag.  Note that the default order is ascending, and */
    /*  therefore the reverse order is descending. */

    Boolean                 rev_ordern;
} ;


/*  End of C Include File */

#endif  /* PSL__PSL_VM_SKEYDEF_LOADED */
