/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECGridCtrl.h: interface for the CECGridCtrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECGRIDCTRL_H__2D7C85E3_6DCE_11D4_A6DC_00500447FC27__INCLUDED_)
#define AFX_CECGRIDCTRL_H__2D7C85E3_6DCE_11D4_A6DC_00500447FC27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GridCtrl.h"
#include "BtnDataBase.h"
#include "GridBtnCell.h"
#include "GridBtnCellCombo.h"
#include "CECSpinEditCell.h"

/////////////////////////////////////////////////////////////////////////////////
// Control Events
#define WMU_CELL_BUTTON_PRESSED     (WM_USER+3000)
#define WMU_SPIN_CELL_CHANGED     (WM_USER+3001)

/////////////////////////////////////////////////////////////////////////////////

class CECGridCtrl : public CGridCtrl
{
public:
	BOOL RemoveButtonDataBase(int nRow,int nCol);
	CBtnDataBase* AddButtonDataBase(int nRow, int nCol);
	void SetCellEnabled(int nRow, int nCol, BOOL bEnabled = TRUE);
    
	typedef struct ButtonData
	{
		int row;
		int col;
		CBtnDataBase* pData;
	};
	
	typedef enum
    {
        ALIGN_CENTER,
        ALIGN_LEFT,
        ALIGN_RIGHT
    }   ALIGN;  // how is DrawFrameControl() aligned?

    void PasteTextFromBuffer(int startRow, int startCol, CString text);
    void SetCheckBoxCellState(int nRow, int nCol, BOOL bCheck,BOOL redraw=TRUE);
    BOOL GetCheckBoxCellState(int nRow, int nCol);


    void CreateCheckCell(int nRow, int nCol);
	void CreateCheckCell(int nRow, int nCol,CGridBtnCellBase::CTL_ALIGN alignment, int width, BOOL redraw,UINT nMarginSize);
    void CreateListCell(int nRow, int nCol, const CStringArray& list);
	void CreateDropListCell(int nRow, int nCol, const CStringArray& list);
    void CreateButtonCell(int nRow, int nCol, CString btnText, ALIGN align = ALIGN_CENTER);
	void CreateButtonCell(int nRow, int nCol, CString btnText, CGridBtnCellBase::CTL_ALIGN align, int iCtlWidth, BOOL redraw,UINT nMarginSize);

    void HandleSpinMsg(CGridBtnCell* pCell);
    CECGridCtrl();
    virtual ~CECGridCtrl();

    void CreateSpinCell(int row, int col, BOOL bNumeric = FALSE);
    CArray<ButtonData,ButtonData> m_BtnDataBase; // holds common properties for button cells
    void SetColumnTextClr( int col, COLORREF rgb);
	void SetNumberOnly(int nRow,int nCol,bool bSet);

    static BOOL GridCtrlInit(HINSTANCE hInst);
protected:

    // Generated message map functions
    //{{AFX_MSG(CECGridCtrl)
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
    int GetNextField(char sep, CString &inStr, CString &field);

private:
    void HandleButtonMsg(CGridBtnCell *pCell, int nRow, int nCol);
};

#endif // !defined(AFX_CECGRIDCTRL_H__2D7C85E3_6DCE_11D4_A6DC_00500447FC27__INCLUDED_)
