/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CTestExecuteDlg.cpp : implementation file
//
#include "stdafx.h"
#include "TestExecuteDlg.h"
#include "process.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BUFSIZE 4096
void executeTest(CTestExecuteDlg* pDlg);

/////////////////////////////////////////////////////////////////////////////
// CTestExecuteDlg dialog
CTestExecuteDlg::CTestExecuteDlg(CString szTest, CWnd* pParent /*=NULL*/)
        : CDialog(CTestExecuteDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CTestExecuteDlg)
    m_strExecStatus = _T("");
    //}}AFX_DATA_INIT
    m_strTest = szTest;
}

CTestExecuteDlg::~CTestExecuteDlg()
{
}


void CTestExecuteDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CTestExecuteDlg)
    DDX_Control(pDX, IDC_EXEC_STATUS, m_ctlExecStatus);
    DDX_Text(pDX, IDC_EXEC_STATUS, m_strExecStatus);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CTestExecuteDlg, CDialog)
//{{AFX_MSG_MAP(CTestExecuteDlg)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestExecuteDlg message handlers

BOOL CTestExecuteDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the initial scroll bar range to 10 lines
    m_ctlExecStatus.SetScrollRange(SB_VERT,0,10,TRUE);

    m_strExecStatus = "Starting...\r\n";
    UpdateData(FALSE);

    m_pExecTestThread = AfxBeginThread(&executeTest, this);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


UINT CTestExecuteDlg::executeTest(LPVOID pParam)
{
    CTestExecuteDlg* pDlg = (CTestExecuteDlg*)pParam;

    try
    {
        CString exeCmd = getenv("OPENSTA_HOME");
        exeCmd += "\\Engines\\";

        exeCmd +="TestManager -T " + pDlg->m_strTest;

        CEdit* pEdit = (CEdit*)pDlg->GetDlgItem(IDC_EXEC_STATUS);
		CString strText = "";
		pEdit->GetWindowText(strText);

		strText += "Starting Test Management System...\r\n";
		pEdit->SetWindowText(strText);
		CTProcess proc(exeCmd.GetBuffer(0));
		proc.start();

		if (!proc.isRunning())
		{
			strText += "Failed to start!\r\n";
			pEdit->SetWindowText(strText);
			return 0;
		}

		strText += "Connecting...\r\n";
		pEdit->SetWindowText(strText);

		strText += "Done";
		pEdit->SetWindowText(strText);

		pDlg->PostMessage(WM_COMMAND, IDOK);
    }
    catch(...)
    {
		pDlg->PostMessage(WM_COMMAND, IDCANCEL);
		return 0;
    }
    return 0;
}



void CTestExecuteDlg::OnCancel()
{
    TerminateThread(m_pExecTestThread->m_hThread,0);

    CDialog::OnCancel();
}
