/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TestPluginView.h : interface of the CTestPluginView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTPLUGINVIEW_H__0298A265_D4CA_11D4_94C7_00C04F89E392__INCLUDED_)
#define AFX_TESTPLUGINVIEW_H__0298A265_D4CA_11D4_94C7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
#include "CustomTabCtrl.h"
#include "mthread.hpp"
class CTestPluginDoc;
class CTestPluginView : public CView
{
protected: // create from serialization only
	CTestPluginView();
	DECLARE_DYNCREATE(CTestPluginView)

// Attributes
public:
	CTestPluginDoc* GetDocument();
	BOOL m_bTestActive;
	CString m_strManagerReg;
	CString m_strTest;
	
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestPluginView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTestPluginView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL CompileScripts();
	BOOL Compile(const CString& strPath);


// Generated message map functions
protected:
	//{{AFX_MSG(CTestPluginView)
	afx_msg void OnCancelEditSrvr();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnExecuteTest();
	afx_msg void OnCompile();
	afx_msg void OnStopTest();
	afx_msg void OnUpdateExecuteTest(CCmdUI* pCmdUI);
	afx_msg void OnUpdateStopTest(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKillTest();
	afx_msg void OnUpdateKillTest(CCmdUI* pCmdUI);
	//}}AFX_MSG
	void OnTabsSelChanging(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()

	CCustomTabCtrl m_ctlTabs;
	CImageList m_TabImages;
	CStringArray m_arstrTabs;

	CLIPFORMAT m_ClipFormat;
	COleDropTarget m_DropTarget;

private:
	BOOL m_bGotStatus;	//false until corba gets m_bTestActive
	BOOL m_bTestExecuteButtonPressed;
	BOOL WriteSummary();
	BOOL m_bSummaryWritten;

	static UINT FindTest(LPVOID);
	CWinThread *m_pTestFindThread;
	HANDLE m_hEndThreadEvent;

	BOOL m_bActivated;

	void Initialise();

};

#ifndef _DEBUG  // debug version in TestPluginView.cpp
inline CTestPluginDoc* CTestPluginView::GetDocument()
   { return (CTestPluginDoc*)m_pDocument; }
#endif


/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTPLUGINVIEW_H__0298A265_D4CA_11D4_94C7_00C04F89E392__INCLUDED_)
