/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TestTabPlugin.h: interface for the CTestKitPlugin class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTTABPLUGIN_H__C6C7559F_A5FA_4D91_B774_4DF3AC40309A__INCLUDED_)
#define AFX_TESTTABPLUGIN_H__C6C7559F_A5FA_4D91_B774_4DF3AC40309A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Plugin.h"
#include "PluginManager.h"
#include "TestFile.h"
class CCORBAInfo;
class CTestTabPlugin  
{
public:
	CTestTabPlugin(CString szTitle,CPluginManager*);
	virtual ~CTestTabPlugin();

	void SetTestFile(CTestFile *pTestFile);
	void SetDocument(CDocument *pDoc);
	int GetNumTabs();
	CDialog* CreateTab(int nTab,CWnd *pParent,CString& strTabName);
	void GetTabImages(CBitmap& bmpTabs);
	BOOL LoadToolBars(CFrameWnd* pWndFrame,CFrameWnd *pOwner);
	void SetCorbaInfo(CCORBAInfo *);
	void SetPluginManager(CPluginManager*);
	void SetTestActive(BOOL bActive,const CString& strReg);
	void LoadMenus(HMENU hMenu);
private:
	CPlugin* m_pPlugin;
};

#endif // !defined(AFX_TESTTABPLUGIN_H__C6C7559F_A5FA_4D91_B774_4DF3AC40309A__INCLUDED_)
