/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// HostDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HostDlg.h"
#include "TestFile.h"
#include "TestCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHostDlg dialog


CHostDlg::CHostDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHostDlg::IDD, pParent),
	m_pTestFile(NULL),
	m_nTaskGroup(-1),
	m_hwndNotify(NULL)
{
	//{{AFX_DATA_INIT(CHostDlg)
	m_strHostName = _T("");
	m_WarningMessage = _T("");
	//}}AFX_DATA_INIT
}


void CHostDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHostDlg)
	DDX_Text(pDX, IDC_HOSTNAME, m_strHostName);
	DDX_Text(pDX, IDC_NO_EDIT, m_WarningMessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHostDlg, CDialog)
	//{{AFX_MSG_MAP(CHostDlg)
	ON_EN_KILLFOCUS(IDC_HOSTNAME, OnKillfocusHostname)
	ON_EN_CHANGE(IDC_HOSTNAME,OnKillfocusHostname)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostDlg message handlers
void CHostDlg::SetTestFile(CTestFile* pTestFile,int nGroup,HWND hwndNotify)
{
	m_pTestFile = pTestFile;
	m_hwndNotify = hwndNotify;

	m_nTaskGroup = nGroup;
	m_strHostName = m_pTestFile->GetTaskGroupHost(m_nTaskGroup);
	
	UpdateData(FALSE);
}		

void CHostDlg::OnKillfocusHostname() 
{
	if(m_nTaskGroup == -1)
		return;

	UpdateData();

	CString strHostName = m_pTestFile->GetTaskGroupHost(m_nTaskGroup);
	if(strHostName == m_strHostName)
		return;

	m_pTestFile->SetTaskGroupHost(m_nTaskGroup,m_strHostName);
	::SendMessage(m_hwndNotify,WMU_REFRESH_LIST,0,MAKELPARAM(m_nTaskGroup+1,CTestCtrl::enHostCol));
}

BOOL CHostDlg::SetWindowEnabled()
{	
	
	//get the cwnd of this dialog
	if(IsWindowEnabled()==FALSE)
	{
		m_WarningMessage="";//This field cannot be edited because the Task group is in use, if a test is running disable the Task group before attempting to edit it";
		GetDlgItem(IDC_HOSTNAME)->EnableWindow(FALSE);
	}
	else
	{
		m_WarningMessage="";//This field can be edited";
		GetDlgItem(IDC_HOSTNAME)->EnableWindow(TRUE);
	}
	UpdateData(FALSE);
	return IsWindowEnabled();
}
