/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_SCRIPTTASKDLG_H__F36DEBC8_4ACA_11D5_94F2_00C04F89E392__INCLUDED_)
#define AFX_SCRIPTTASKDLG_H__F36DEBC8_4ACA_11D5_94F2_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ScriptTaskDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CScriptTaskDlg dialog
#include "ScriptDefData.h"
#include "resource.h"
class CTestFile;
class CScriptTaskDlg : public CDialog
{
// Construction
public:
	CScriptTaskDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CScriptTaskDlg)
	enum { IDD = IDD_SCRIPTTASK_DLG };
	CSpinButtonCtrl	m_ctlDurationSpin;
	CComboBox	m_ctlTerminationType;
	CSpinButtonCtrl	m_ctlMinDelaySpin;
	CSpinButtonCtrl	m_ctlMaxDelaySpin;
	CSpinButtonCtrl	m_ctlIterSpin;
	CSpinButtonCtrl	m_ctlFixedDelaySpin;
	CComboBox	m_ctlDelayType;
	int		m_nFixedDelay;
	int		m_nIterations;
	int		m_nMaxDelay;
	int		m_nMinDelay;
	int		m_nDuration;
	CString	m_WarningString;
	//}}AFX_DATA

	BOOL SetWindowEnabled();
	void SetTestFile(CTestFile* pTestFile,int nGroup,int nTask,HWND hwndNotify);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScriptTaskDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CScriptTaskDlg)
	afx_msg void OnSelchangeTerminationType();
	afx_msg void OnSelchangeDelayType();
	afx_msg void OnChangeIterations();
	afx_msg void OnChangeDuration();
	afx_msg void OnChangeFixedDelay();
	afx_msg void OnChangeMaxDelay();
	afx_msg void OnChangeMinDelay();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	void SaveDataToTestFile();

	CTestFile *m_pTestFile;
	CScriptDefData m_SDData;

	HWND m_hwndNotify;
	int m_nTaskGroup;
	int m_nTask;

	
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCRIPTTASKDLG_H__F36DEBC8_4ACA_11D5_94F2_00C04F89E392__INCLUDED_)
