/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// TestSummaryWnd.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "TestSummaryWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestSummaryWnd

CTestSummaryWnd::CTestSummaryWnd()
{
}

CTestSummaryWnd::~CTestSummaryWnd()
{
}


BEGIN_MESSAGE_MAP(CTestSummaryWnd, CEdit)
	//{{AFX_MSG_MAP(CTestSummaryWnd)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EXPORT, OnExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestSummaryWnd message handlers

void CTestSummaryWnd::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	//This block was added by the Pop-up Menu component
    if (point.x == -1 && point.y == -1)
    {
        //keystroke invocation
        CRect rect;
        GetClientRect(rect);
        ClientToScreen(rect);

        point = rect.TopLeft();
        point.Offset(5, 5);
    }

    CMenu menu;
	VERIFY(menu.LoadMenu(IDR_TEST_SUMMARY_MENU));

	CMenu *pSub = menu.GetSubMenu(0);

    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);

    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,this);
}

void CTestSummaryWnd::SetFile(const CString& strFile)
{
	CFile f;
	f.Open(strFile,CFile::modeRead);
	int nLength = f.GetLength();
	char *szBuffer = new char[nLength+1];
	f.Read(szBuffer,nLength);
	szBuffer[nLength] = NULL;
	f.Close();

	SetWindowText(szBuffer);
	delete []szBuffer;
}

BOOL CTestSummaryWnd::Create(const CRect& rcWnd,CWnd* pParent)
{
	return CEdit::Create(ES_READONLY|ES_MULTILINE|WS_VSCROLL|WS_HSCROLL|WS_CHILD|WS_VISIBLE|WS_BORDER,rcWnd,pParent,0);
}

void CTestSummaryWnd::OnExport() 
{
    CFileDialog dlg(FALSE,"txt","Summary.txt",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Text Files (*.txt)|*.txt||",this);
    if(dlg.DoModal() != IDOK)
        return;

    CString strPath(dlg.GetPathName());

    CStdioFile f;
    if(!f.Open(strPath,CFile::modeWrite|CFile::modeCreate))
    {
        CString strMsg;
        strMsg.Format("Failed to open the export file \"%s\"",strPath);
        MessageBox(strMsg,"Audit",MB_ICONEXCLAMATION|MB_OK);
        return;
    }

	CString strTxt;
	GetWindowText(strTxt);

	f.WriteString(strTxt);
	f.Close();

    MessageBox("Export complete","Summary",MB_ICONINFORMATION|MB_OK);
}
