/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include "stdafx.h"
#include "LogTrace.hpp"

const char* LogTrace::LevelToTraceList(int iLevel)
{
    const char* pTraceList;
    if(     iLevel < TRCLEV_LOW)
        pTraceList = "";
    else if(iLevel < TRCLEV_MEDIUM)
        pTraceList = "errors";
    else if(iLevel < TRCLEV_HIGH)
        pTraceList = "errors connection request sync SecureSocket";
    else // iLevel >= TRCLEV_HIGH
        pTraceList = "errors connection request sync SecureSocket full Startup Shutdown ScriptCommand Debug-Generic Note Audit Repository";

    return pTraceList;
}

void LogTrace::AddTrace(const char* zCategory, int iLevel, const std::string& strMsg)
{
#ifdef CYRANO_TP_STANDALONE
    if(iLevel >= TRCLEV_HIGH)
    {
        // Normal logging.
        PostMessage(m_hwnd, WM_APP+1, 0, (LPARAM)(new std::string(strMsg)));
    }
    else
    {
        // Error logging.
        PostMessage(m_hwnd, WM_APP+2, 0, (LPARAM)(new std::string(strMsg)));
    }
#endif
    // Log to the local trace file.
    if(m_pTrace && m_pTrace->IsTrace(LevelToTraceList(iLevel), FALSE))
    {
        GetTraceStream(m_pTrace) << zCategory << ": " << strMsg << ".\r\n";
        ReleaseTraceStream();
    }
}
