/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _OPENSTA_LOGTRACE_H_
#define _OPENSTA_LOGTRACE_H_

////////////////////////////////////////////////////////////////////////////////
// OpenSTA logging. Uses thread pool CTrace class.
////////////////////////////////////////////////////////////////////////////////

#include "OstaTraceDef.h"
#include "Trace.hpp"


class LogTrace
{
public:
#ifdef CYRANO_TP_STANDALONE
    LogTrace(CTrace* pTrace, HWND hWnd) : m_pTrace(pTrace), m_hwnd(hWnd) {}
#else
    LogTrace(CTrace* pTrace) : m_pTrace(pTrace) {}
#endif
    static const char* LevelToTraceList(int iLevel);
    CTrace* GetTrace() {return m_pTrace;}
    void AddTrace(const char* zCategory, int iLevel, const std::string& strMsg);

private:
    //// Data
    CTrace* m_pTrace;
#ifdef CYRANO_TP_STANDALONE
    HWND    m_hwnd;         // Modeler's trace output window.
#endif

    //// Forbidden
    LogTrace();
    LogTrace(const LogTrace&);
    operator=(const LogTrace&);
};

extern LogTrace* g_pLogTrace;

#endif  // _OPENSTA_LOGTRACE_H_
