/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// SCLCommentsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "modeller.h"
#include "SCLCommentsDlg.h"
#include "htmlhelp.h"
#include "Help\SCLCommentsDlg.inl"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSCLCommentsDlg dialog
//---------------------------------------------------------------------------

CSCLCommentsDlg::CSCLCommentsDlg(CString *pstrComments /*= NULL*/ , CWnd* pParent /*=NULL*/)
        : CDialog(CSCLCommentsDlg::IDD, pParent),
        m_pstrComments( pstrComments )
{}

//---------------------------------------------------------------------------


void CSCLCommentsDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSCLCommentsDlg)
    //}}AFX_DATA_MAP
}

//---------------------------------------------------------------------------


BEGIN_MESSAGE_MAP(CSCLCommentsDlg, CDialog)
//{{AFX_MSG_MAP(CSCLCommentsDlg)
ON_WM_CTLCOLOR()
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCLCommentsDlg message handlers
//---------------------------------------------------------------------------

BOOL CSCLCommentsDlg::OnInitDialog()
{
    CDialog::OnInitDialog();
    CEdit * pEdit;

    pEdit = (CEdit *)GetDlgItem( IDC_EDIT_COMMENT );
    pEdit->SetFocus();

    return FALSE;
}

//---------------------------------------------------------------------------

HBRUSH CSCLCommentsDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
    HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

    if( nCtlColor == CTLCOLOR_STATIC && pWnd->m_hWnd == GetDlgItem(IDC_PRESENT_COMMENT)->m_hWnd )
    {
        pDC->SetTextColor( RGB( 0 , 0 , 255 ) ) ;
    }

    return hbr;
}

//---------------------------------------------------------------------------

void CSCLCommentsDlg::OnOK()
{
    Ctrl2Values() ;
    CDialog::OnOK();
}

//---------------------------------------------------------------------------

void CSCLCommentsDlg::Ctrl2Values()
{
    GetDlgItem( IDC_EDIT_COMMENT )->GetWindowText( (* m_pstrComments) ) ;
}

BOOL CSCLCommentsDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp;
    contextHelp.LoadString(IDS_MODELLER_HELP_FILE);
    contextHelp= getenv("OPENSTA_HOME")+contextHelp+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
