/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// SCLDocInfo.h: interface for the CSCLDocInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCLDOCINFO_H__F4271C21_11E1_11D4_9322_00104B4B2995__INCLUDED_)
#define AFX_SCLDOCINFO_H__F4271C21_11E1_11D4_9322_00104B4B2995__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ConstantesLib.h>

class CSCLDocInfo
{
private:
    CString m_strProjectName;
    CString m_strSCLFileName;
    long    m_lBrowserID;

    CString m_strWorkingFolder;
	CString m_strOriginalPath;
public:
    CSCLDocInfo();
    virtual ~CSCLDocInfo();

	void SetOriginalPath(const CString& strPath){m_strOriginalPath = strPath;}
    void SetProjectName(CString _strProjectName);
    void SetFileInfo(CString _strSCLFileName, long _lBrowserID = ID_BROWSER_NONE);
    void SetBrowserID(long _lBrowserID);
    void SetWorkingFolder(const CString& strFolder)
    {
        m_strWorkingFolder = strFolder;
    }

    long    GetBrowserID();

    BOOL    IsProjectNameEmpty();

    CString GetProjectName();
    CString GetSCLName();

    CString GetSCLFileName();
    CString GetTOFFileName();
    CString GetALLFileName();

    CString GetProjectPath();
    CString GetTmpProjectPath();
    CString GetWorkingFolder()
    {
        return m_strWorkingFolder;
    }
    CString GetSCLPath();
    CString GetTOFPath();
    CString GetALLPath();
    CString GetFVRPath();

    CString GetFullSCLFileName();
    CString GetFullTOFFileName();
    CString GetFullALLFileName();
	
	CString GetOriginalPath(){return m_strOriginalPath;}
};

#endif // !defined(AFX_SCLDOCINFO_H__F4271C21_11E1_11D4_9322_00104B4B2995__INCLUDED_)
