/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_MONITORGRAPH_H__4B7B2D64_1A3B_4ACC_BC50_DE6A6DC3B56E__INCLUDED_)
#define AFX_MONITORGRAPH_H__4B7B2D64_1A3B_4ACC_BC50_DE6A6DC3B56E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonitorGraph.h : header file
//
#include "xchartctrl.h"
#include "Resource.h"
/////////////////////////////////////////////////////////////////////////////
// CMonitorGraph dialog
typedef struct
{
	CString strDesc;
	CXChartCtrl* pChart;
	int nDataIndex;
} GRAPH_INFO;

typedef struct 
{
	int nTaskgroup;
	int nIndex;
}loadedgraph;

class CMonitorGraph : public CDialog
{
// Construction
public:
	void LoadHeaders();
	void InitMonitor(CString strRunFolder, CStringArray& arrDesc);
	CMonitorGraph(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CMonitorGraph)
	enum { IDD = IDD_GRAPH_DLG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonitorGraph)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	afx_msg BOOL OnEraseBkgnd( CDC* pDC );
	// Generated message map functions
	//{{AFX_MSG(CMonitorGraph)
	virtual BOOL OnInitDialog();
	afx_msg	void ToggleRollingGraphs();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point) ;
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int m_nRollingChecked;
	int	m_nTaskGroup;

	void LoadGraphStyles();

	int m_nFilePos;

	CWnd* m_pParent;

	CString m_strDesc;
	CString m_strRunFolder;
	CXChartCtrl* CreateDisplay(CString strTitle);
	int GetNextField(char sep, CString &inStr, CString &field);
	CArray<GRAPH_INFO,GRAPH_INFO> m_arrGraphs;
	CStdioFile m_dataFile;
	BOOL m_bDataFileOpen;
	BOOL m_bHeadersLoaded;
	CStringArray m_arrDescriptions;


    COLORREF m_colPlotBk;
    CString m_strLabelFont;
    COLORREF m_colGrid;
    COLORREF m_colLabel;
    COLORREF m_colAxisText;
	CDWordArray m_arDefLineColours;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONITORGRAPH_H__4B7B2D64_1A3B_4ACC_BC50_DE6A6DC3B56E__INCLUDED_)
